<?php
// ----------------------------------------------------------------------
// phpNewsfork - Version 0.2
// http://www.borho.net/news/
// (c) 2001-2002 Martin Borho (martin@borho.net)
//
// LICENSE
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
include("xmlrpc_m.inc");
include("syndic8.inc");

// get the input-variables
$pattern = $_REQUEST["pattern"];
$syn8_lang = $_REQUEST["syn8_lang"];
$syndicated = $_POST["syndicated"];
$polling = $_POST["polling"];
$approval = $_POST["approval"];

$get_feed = $_GET["get_feed"];
$version = $_GET["version"];
// if there's missing user-input
if (!$pattern and !$get_feed) die ("<u><i>no searchpattern is given!</i></u>");

// instance of syndic8
$news = new syndic8;

// if a searchpattern is given
if ($pattern) {
        // get mode-string or build mode-string
        $mode = $_GET["mode"];
        if (!$mode) $mode = "s$syndicated-p$polling-a$approval";
        // build a string containing the choosen stats
        if (strstr("$mode", "s1-")) $stats = "-Syndicated-";
        if (strstr("$mode", "-p1"))  $stats .= "-Polling-";
        if (strstr("$mode", "-a1")) $stats .= "-AwaitingApproval-";
        // if there is no user-input for stats...
        if (!$stats) die ("<u><i>no status is specified</i></u>");
        echo "<html>\n<head>\n<title>xmlrpc</title>\n</head>\n<body>\n";
        // if it's the first interval to display - let's start at zero
        if (!$startItem) $startItem = "0";

        // make a request at syndic8.com
        $content = $news->getSyndic8("$pattern", "$syn8_lang", "$startItem", "$mode");

        // show the results - first some infos, then a navbar
        echo "<u><i>Pattern: <b>\"$pattern\"</b> / Language=$syn8_lang</i></u><br><br>";
        echo "$content[nav]<br><br>";

        // go through the result and display only the channels with the choosen stats
        foreach ($content[channels] as $key => $value) {
                extract($value);
                if (strstr($stats, "-$status-")) {
                        $x++;
                        echo utf8_decode("<a href=\"syndic8.php?get_feed=".rawurlencode("$dataurl")."&version=$rss_version\">$sitename</a><br>$description<br><br>\n");
                }
        }

     echo "$content[nav]";
     // no matching channels...
     if (!$x) echo "sorry, no channels were found.";
     echo "<hr><br><small><i>data by&nbsp;</i></small><a href=\"http://www.syndic8.com\" target=\"new\"><img src=\"syndic8logo.jpg\" border=\"0\"></a>";
     echo "</body></html>";
}

// if a newsfeed is requested
if ($get_feed != "") {
     // make the url readable
     $get_feed = urldecode($get_feed);
     // load the rss-file from the URL
     $xml = $news->load_ext_file($get_feed);

     // prepare string for parsing
     $xml = utf8_encode($xml);
     $xml = eregi_replace(">"."[[:space:]]+"."<", "><", $xml);


     $xml_parser = xml_parser_create();
     xml_parse_into_struct($xml_parser, $xml, $news)
     // Handle errors in parsing
     or die(sprintf("<b>XML error:</b> %s at line %d", xml_error_string(xml_get_error_code($xml_parser)), xml_get_current_line_number($xml_parser)));
     // Free up memory used by the XML parser
     xml_parser_free($xml_parser);

     foreach($news as $k => $v) {
        extract($v);
        //catch some RDF-exceptions
        if ($type == "open" && $tag == "CHANNEL") $node = $tag;
        if ($type == "open" && $tag == "IMAGE") $node = $tag;
        if ($type == "open" && $tag == "ITEM") $node = $tag;

        ${$node}[$tag] = $value;
        
        if($tag == "TITLE" && $node == "ITEM") $title ="$value";
        if($tag == "DESCRIPTION" && $node == "ITEM") $desc ="$value";
        if($tag == "LINK" && $node == "ITEM") $link = $value;
        
        if($node == "ITEM" && $type == "close") {
               $articles .= "<p><a href=\"$link\" target=\"new\">$title</a><br>\n$desc\n</p>\n";
               $node = "";
        }
    }

$result = "<html>\n<head>\n<title>$CHANNEL[TITLE]</title>\n</head>\n<body>\n<a href=\"$CHANNEL[LINK]\" target=\"new\"><h1>$CHANNEL[TITLE]</h1></a>\n$CHANNEL[DESCRIPTION]\n";
$result .= $articles;
if($IMAGE[LINK]) {
        $result .= "<p><a href=\"$IMAGE[LINK]\" target=\"new\"><img src=\"$IMAGE[URL]\" border=\"0\" alt=\"$IMAGE[TITLE]\"/></a></p>\n";
}
$result .= "<br><a href=\"javascript:history.back()\">back</a><br>\n";
$result .= "</BODY></HTML>";


     // translate the html-entities in the result
     $trans = get_html_translation_table (HTML_ENTITIES);
     $trans = array_flip($trans);
     $result = strtr($result, $trans);

     $result = str_replace("","&auml;",$result);
     $result = str_replace("","&ouml;",$result);
     $result = str_replace("","&uuml;",$result);
     $result = str_replace("","&Auml;",$result);
     $result = str_replace("","&Uuml;",$result);
     $result = str_replace("","&Ouml;",$result);
     $result = str_replace("","&szlig;",$result);


     // Output the resulting HTML in ISO-8859-1
     echo utf8_decode($result);
}
?>
